unit JwwGaibu;

interface

uses
   SysUtils, MyFunc ;

type
   TJwwMojisyu = record
      w : double ;
      h : double ;
      d : double ;
      col : integer ;
   end;
   TJwwIndPoint = record
      flg : Boolean ;   // True:w False:w
      x : double ;
      y : double ;
      sta : integer ;   // 0: 1:- 2:ln 3:ci 4:ch
   end;

var
   JG_Jikukaku : double ;     // p[]
   JG_ZumenFile : string ;    // }ʃt@C
   JG_LGrpScale : array[0..15] of double ;   // CO[vkڕ
   JG_ZumenXsize, JG_ZumenYsize : double ;   // }ʃTCY
   JG_Mojisyu : array[1..10] of TJwwMojisyu; // ݒ
   JG_Zusun : Boolean ;       // (False)A}(True)
   JG_AreaX1, JG_AreaY1 : double ;  // Í͈@_
   JG_AreaX2, JG_AreaY2 : double ;  // Í͈@E_
   JG_CurLGrp : integer ;     // ݂̃CO[v
   JG_CurLay  : integer ;     // ݂̃C
   JG_CurCol  : integer ;     // ݂̐F
   JG_CurLtp  : integer ;     // ݂̐
   JG_CurWid  : integer ;     // ݂̐[1/100mmP]
   JG_CurMjs  : integer ;     // ݂̕
   JG_CurMjsW,JG_CurMjsH,JG_CurMjsD : double ;  // CӃTCY̏ꍇ
   JG_CurMjsC : integer ;                       //    EE
   JG_CurFont : string ;      // ݂̕tHg
   JG_IPoints : array of TJwwIndPoint ;   // w_
   JG_IPointN : integer ;                 // w_
   // CԁEC
   JG_LGrpStat : array of integer ;    // CO[v
   JG_LGrpName : array of string ;     // CO[v
   JG_LayStat  : array of integer ;    // C
   JG_LayName  : array of string ;     // C

   // ʗptO True:l݁` False:݂ł͂Ȃ
   JGW_FlgLGrp : Boolean ;    // CO[v
   JGW_FlgLay  : Boolean ;    // C
   JGW_FlgCol  : Boolean ;    // F
   JGW_FlgLtp  : Boolean ;    // 
   JGW_FlgWid  : Boolean ;    // 
   JGW_FlgMjs  : Boolean ;    // 
   // ovff[^ɕt鑮
   JGW_IPNo : integer ;       // w_vfw̍ۂ̔ԍ 0:Ivf
   JGW_LGrp : integer ;       // CO[v
   JGW_Lay  : integer ;       // C
   JGW_Col  : integer ;       // F
   JGW_Ltp  : integer ;       // 
   JGW_Wid  : integer ;       // [1/100mmP]
   JGW_Mjs  : integer ;       // 
   JGW_MjsW,JGW_MjsH,JGW_MjsD : double ;  // CӃTCY̏ꍇ
   JGW_MjsC : integer ;                   //    EE
   JGW_Mbs  : integer ;       // _ 0: 1: 2:E 3: 4: 5:E 6: 7: 8:E
   JGW_Font : string ;        // tHg
   JGW_Attr : integer ;       //  +1:nb` +2:}` +4:@ +8:(ΏۊO) +16:(Ώ)
   JGW_CrvNo: integer ;       // Ȑf[^ԍ
   JGW_CrvFl: Boolean ;       // Ȑf[^ۂ
   JGW_DimFl: Boolean ;       // @}`tO(ȍ~AE@l)
   JGW_PtCol: integer ;       // _F
   JGW_SlCol: integer ;       // \bh}`CӐF

   procedure InitJwwGaibu ;
   procedure EndJwwGaibu ;
   function OpenTempFile(fn:string) : Boolean ;
   function SaveTempFile(fn:string) : Boolean ;

implementation

// ϐ
procedure InitJwwGaibu ;
var
   i : integer ;
begin
   JG_Jikukaku := 0.0 ;
   JG_ZumenFile := '' ;
   for i:=0 to 15 do
      JG_LGrpScale[i] := 1.0 ;
   JG_ZumenXsize := 1189.0 ;
   JG_ZumenYsize :=  841.0 ;  // A0
   for i:=1 to 10 do begin
      with JG_Mojisyu[i] do begin
         w := 3.0 ;
         h := 3.0 ;
         d := 0.0 ;
         col := 2 ;
      end;
   end;
   JG_Zusun := False ;
   JG_AreaX1 := 0.0 ;
   JG_AreaY1 := 0.0 ;
   JG_AreaX2 := 0.0 ;
   JG_AreaY2 := 0.0 ;
   JG_CurLGrp := 0 ;
   JG_CurLay  := 0 ;
   JG_CurCol  := 1 ;
   JG_CurLtp  := 1 ;
   JG_CurWid  := 0 ;
   JG_CurMjs  := 1 ;
   JG_CurMjsW := 2.0;
   JG_CurMjsH := 2.0;
   JG_CurMjsD := 0.0;
   JG_CurMjsC := 1;
   JG_CurFont := '' ;
   //
   SetLength(JG_LGrpStat,16);
   SetLength(JG_LGrpName,16);
   SetLength(JG_LayStat,256);
   SetLength(JG_LayName,256);
   for i:=0 to 15 do begin
      JG_LGrpStat[i] := 0;
      JG_LGrpName[i] := '';
   end;
   for i:=0 to 255 do begin
      JG_LayStat[i] := 0;
      JG_LayName[i] := '';
   end;
   //
   SetLength(JG_IPoints, 100);
   for i:=0 to 99 do begin
      with JG_IPoints[i] do begin
         flg := False;
         x := 0.0;
         y := 0.0;
         sta := 0;
      end;
   end;
   JG_IPointN := 0 ;
   //
   JGW_FlgLGrp := True;
   JGW_FlgLay  := True;
   JGW_FlgCol  := True;
   JGW_FlgLtp  := True;
   JGW_FlgWid  := True;
   JGW_FlgMjs  := True;
   //
   JGW_IPNo := 0;
   JGW_LGrp := 0;
   JGW_Lay  := 0;
   JGW_Col  := 1;
   JGW_Ltp  := 1;
   JGW_Wid  := 0;
   JGW_Mjs  := 1;
   JGW_MjsW := 2.0;
   JGW_MjsH := 2.0;
   JGW_MjsD := 0.0;
   JGW_MjsC := 1;
   JGW_Mbs  := 0;
   JGW_Font := '<lr SVbN>';
   JGW_Attr := 0;
   JGW_CrvNo:= 0;
   JGW_CrvFl:= False;
   JGW_DimFl:= False;
   JGW_PtCol:= 1;
   JGW_SlCol:= 0;
end;

// ϐŏI
procedure EndJwwGaibu ;
begin
   JG_LGrpStat := nil;
   JG_LGrpName := nil;
   JG_LayStat  := nil;
   JG_LayName  := nil;
   JG_IPoints  := nil;
end;

// JWC_TEMP.TXT ǂݍ͕݉
procedure GetTempCode(codes:string);
var
   pa : array of string ;
   i,j,n : integer ;
   mflag : Boolean ;
   s : string ;
begin
   if (codes = '') then exit ;
   SetLength(pa,32) ;   // ߂ɃmۂĂ܂
   for i:=0 to 31 do
      pa[i] := '';      // e܂iԁj
   // p󔒂؂Ƃĕ
   i := 1 ;
	j := 0 ;
	n := Length(codes) ;
   mflag := True ;
	while(i <= n) do begin
		if (Ord(codes[i]) >= 128)and(Ord(codes[i]) <= 159)
       or(Ord(codes[i]) >= 224)and(Ord(codes[i]) <= 253) then begin
         if ((i+1) > n) then break ;   // G[
         // Sp
         pa[j] := pa[j] + codes[i] + codes[i+1] ;
			Inc(i);
      end
      else if (codes[i] = '"')and(mflag) then begin
         mflag := False ;  // u"vȍ~͕F󔒂͋؂ɂȂȂ
      end
      else if (codes[i] = '=')and(mflag) then begin
         pa[j] := pa[j] + codes[i] ;   // u=v܂߂
         mflag := False ;  // u=vȍ~͕F󔒂͋؂ɂȂȂ
      end
      else if ((codes[i] = ' ')or(codes[i] = #9))and(mflag) then begin
         // ؂蕶
         if (pa[j] <> '') then
            Inc(j);  // p󔒂2ȏ̏ꍇւ̏u
      end
		else if (Ord(codes[i]) < 32)or(Ord(codes[i]) > 253) then begin
         // R[h̏ꍇ͉Ȃ
      end
      else begin
         // p
         pa[j] := pa[j] + codes[i] ;
      end;
      Inc(i);
   end;
   n := j + 1;    // 
   if (n = 1)and(pa[0] = '') then begin
      pa := nil ;
      exit ;
   end;

   // eݒe̓ǂݍ
   if (AnsiPos('file=',pa[0]) > 0) then begin
      // }ʃt@C
      JG_ZumenFile := Copy(pa[0],6,Length(pa[0]));
   end
   else if (pa[0] = 'hk')and(n >= 2) then begin
      // p
      JG_Jikukaku := SDbl(pa[1]) ;
   end
   else if (pa[0] = 'hs')and(n >= 17) then begin
      // CO[vkڕ
      for i:=0 to 15 do
         JG_LGrpScale[i] := SDbl(pa[i+1]);
   end
   else if (pa[0] = 'hzs')and(n >= 3) then begin
      // }ʃTCY
      JG_ZumenXsize := SDbl(pa[1]) ;
      JG_ZumenYsize := SDbl(pa[2]) ;
   end
   else if (pa[0] = 'hcw')and(n >= 11) then begin
      // ^
      for i:=1 to 10 do
         JG_Mojisyu[i].w := SDbl(pa[i]) ;
   end
   else if (pa[0] = 'hch')and(n >= 11) then begin
      // ^
      for i:=1 to 10 do
         JG_Mojisyu[i].h := SDbl(pa[i]) ;
   end
   else if (pa[0] = 'hcd')and(n >= 11) then begin
      // ^Ԋu
      for i:=1 to 10 do
         JG_Mojisyu[i].d := SDbl(pa[i]) ;
   end
   else if (pa[0] = 'hcc')and(n >= 11) then begin
      // ^F
      for i:=1 to 10 do
         JG_Mojisyu[i].col := SInt(pa[i]) ;
   end
   else if (pa[0] = 'bz') then begin
      // }
      JG_Zusun := True ;
   end
   else if (pa[0] = 'hn')and(n >= 5) then begin
      // I͈
      JG_AreaX1 := SDbl(pa[1]) ;
      JG_AreaY1 := SDbl(pa[2]) ;
      JG_AreaX2 := SDbl(pa[3]) ;
      JG_AreaY2 := SDbl(pa[4]) ;
   end
   else if (AnsiPos('lgn',pa[0]) = 1) then begin
      s := Copy(pa[0],4,Length(pa[0])) ;
      JG_LGrpName[JGW_LGrp] := s;
   end
   else if (AnsiPos('lyn',pa[0]) = 1) then begin
      s := Copy(pa[0],4,Length(pa[0])) ;
      JG_LayName[JGW_LGrp*16+JGW_Lay] := s;
   end
   else if (AnsiPos('lg',pa[0]) = 1) then begin
      i := SInt('$'+Copy(pa[0],3,1)) ;
      if (i < 0)or(i > 15) then i:=0;  // ꉞ}
      if (JGW_FlgLGrp) then begin
         // ݂̃CO[v
         JG_CurLGrp := i;
         JGW_FlgLGrp := False;
      end;
      JGW_LGrp := i;
      if (n >= 2) then begin
         JG_LGrpStat[JGW_LGrp] := SInt(pa[1]);
      end;
   end
   else if (AnsiPos('ly',pa[0]) = 1) then begin
      i := SInt('$'+Copy(pa[0],3,1)) ;
      if (i < 0)or(i > 15) then i:=0;  // ꉞ}
      if (JGW_FlgLay) then begin
         // ݂̃C
         JG_CurLay := i;
         JGW_FlgLay := False;
      end;
      JGW_Lay := i;
      if (n >= 2) then begin
         JG_LayStat[JGW_LGrp*16+JGW_Lay] := SInt(pa[1]);
      end;
   end
   else if (AnsiPos('lc',pa[0]) = 1) then begin
      i := SInt(Copy(pa[0],3,Length(pa[0]))) ;
      if (JGW_FlgCol) then begin
         // ݂̐F
         JG_CurCol := i;
         JGW_FlgCol := False;
      end;
      JGW_Col := i;
      if (JGW_Col = 10)and(n >= 2) then begin
         JGW_SlCol := SInt(pa[1]);
      end;
   end
   else if (AnsiPos('lt',pa[0]) = 1) then begin
      i := SInt(Copy(pa[0],3,Length(pa[0]))) ;
      if (JGW_FlgLtp) then begin
         // ݂̐
         JG_CurLtp := i;
         JGW_FlgLtp := False;
      end;
      JGW_Ltp := i;
   end
   else if (AnsiPos('lw',pa[0]) = 1) then begin
      i := SInt(Copy(pa[0],3,Length(pa[0]))) ;
      if (JGW_FlgWid) then begin
         // ݂̐
         JG_CurWid := i;
         JGW_FlgWid := False;
      end;
      JGW_Wid := i;
   end
   else if (AnsiPos('cn$',pa[0]) = 1) then begin
      s := Copy(pa[0],4,Length(pa[0])) ;
      if (JG_CurFont = '') then begin
         // ݂̕tHg
         JG_CurFont := s;
      end;
      JGW_Font := s;
   end
   else if (AnsiPos('cn',pa[0]) = 1) then begin
      i := SInt(Copy(pa[0],3,Length(pa[0]))) ;
      if (JGW_FlgMjs) then begin
         // ݂̕
         JG_CurMjs := i;
         if (JG_CurMjs = 0)and(n >= 5) then begin
            JG_CurMjsW := SDbl(pa[1]) ;
            JG_CurMjsH := SDbl(pa[2]) ;
            JG_CurMjsD := SDbl(pa[3]) ;
            JG_CurMjsC := SInt(pa[4]) ;
         end;
         JGW_FlgMjs := False;
      end;
      JGW_Mjs := i;
      if (JGW_Mjs = 0)and(n >= 5) then begin
         JGW_MjsW := SDbl(pa[1]) ;
         JGW_MjsH := SDbl(pa[2]) ;
         JGW_MjsD := SDbl(pa[3]) ;
         JGW_MjsC := SInt(pa[4]) ;
      end;
   end
   else if (AnsiPos('cc',pa[0]) = 1) then begin
      i := SInt(Copy(pa[0],3,1)) ;
      if (i < 0)or(i > 8) then i:=0;
      JGW_Mbs := i;
   end
   else if (pa[0] = 'z1') then begin
      // nb`
      if ((JGW_Attr and 1) = 0) then
         JGW_Attr := JGW_Attr + 1;
   end
   else if (pa[0] = 'z2') then begin
      // }`
      if ((JGW_Attr and 2) = 0) then
         JGW_Attr := JGW_Attr + 2;
   end
   else if (pa[0] = 'z3') then begin
      // @
      if ((JGW_Attr and 4) = 0) then
         JGW_Attr := JGW_Attr + 4;
   end
   else if (pa[0] = 'z4') then begin
      // iΏۊO̎wj
      if ((JGW_Attr and 8) = 0) then
         JGW_Attr := JGW_Attr + 8;
   end
   else if (pa[0] = 'z5') then begin
      // iΏ ̎wj
      if ((JGW_Attr and 16) = 0) then
         JGW_Attr := JGW_Attr + 16;
   end
   else if (AnsiPos('pn',pa[0]) = 1) then begin
      // _̐Fԍ
      JGW_PtCol := SInt(Copy(pa[0],3,Length(pa[0]))) ;
   end
   else if (pa[0] = 'pl') then begin
      // Ȑf[^i㑱̐f[^ɂ̂ݗLj
      Inc(JGW_CrvNo);
      JGW_CrvFl := True;
      JGW_DimFl := False;  // @}`[h
   end
   else if (pa[0] = 'msg') then begin
      // @}`f[^i㑱̐E@lf[^ɉej
      JGW_DimFl := True;
      JGW_CrvFl := False;  // Ȑf[^
   end
   else if (pa[0] = '#') then begin
      // Rg
      // Ȑf[^̃GhR[hƂĂp
      JGW_CrvFl := False;
      JGW_DimFl := False;  // @}`ɂGhR[hH
   end
   //
   // w_̓ǂݍ
   else if (AnsiPos('hp',pa[0]) = 1)and(n >= 3) then begin
      j := 0 ;
      s := Copy(pa[0],3,Length(pa[0]));
      i := AnsiPos('-',pa[0]);
      if (i > 0) then begin
         s := Copy(pa[0],3,i-3);
         j := 1;
      end;
      i := AnsiPos('ln',pa[0]);
      if (i > 0) then begin
         s := Copy(pa[0],3,i-3);
         j := 2;
      end;
      i := AnsiPos('ci',pa[0]);
      if (i > 0) then begin
         s := Copy(pa[0],3,i-3);
         j := 3;
      end;
      i := AnsiPos('ch',pa[0]);
      if (i > 0) then begin
         s := Copy(pa[0],3,i-3);
         j := 4;
      end;
      i := SInt(s) ;
      if (i >= 1)and(i <= 99) then begin
         with JG_IPoints[i] do begin
            flg := True;
            x := SDbl(pa[1]);
            y := SDbl(pa[2]);
            sta := j;
         end;
         Inc(JG_IPointN);
      end;
   end
   else if (AnsiPos('hhp',pa[0]) = 1) then begin
      j := Length(pa[0]);
      i := AnsiPos('ln',pa[0]);  if (i > 4) then j := i-4;
      i := AnsiPos('ci',pa[0]);  if (i > 4) then j := i-4;
      i := AnsiPos('ch',pa[0]);  if (i > 4) then j := i-4;
      s := Copy(pa[0],4,j);
      JGW_IPNo := SInt(s);
   end;

   pa := nil;  // ܂
end;

// Jw_cad Oό`
//@of[^uJWC_TEMP.TXTvǂݍ
//    fn : t@C(tpX)
// (ret)
//    True : OK@@False : Error
function OpenTempFile(fn:string) : Boolean ;
var
   F : TextFile ;
   s : string ;
begin
   // ǂݍ
   Result := False ;
   if not(FileExists(fn)) then exit;
   try
      AssignFile(F, fn);
      FileMode := 0;
      Reset(F);
      while not(Eof(F)) do begin
         ReadLn(F, s);
         GetTempCode(s);
      end;
      CloseFile(F);
      Result := True ;
   except
      CloseFile(F);
   end;
end;

// Jw_cad Oό`
//@of[^uJWC_TEMP.TXTvۑ
//    fn : t@C(tpX)
// (ret)
//    True : OK@@False : Error
function SaveTempFile(fn:string) : Boolean ;
var
   F : TextFile ;
   s : string ;
begin
   Result := False ;
   try
      AssignFile(F, fn);
      ReWrite(F);

      s := 'hq' ;
      WriteLn(F, s);

      CloseFile(F);
      Result := True ;
   except
      CloseFile(F);
      if FileExists(fn) then
         DeleteFile(fn);
   end;
end;

end.
